// ProcessMonitorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ProcessMonitor.h"
#include "ProcessMonitorDlg.h"
#include ".\processmonitordlg.h"
#include "alertDlg.h"
#include <psapi.h>
#include <vector>
#include <fstream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CProcessMonitorDlg dialog



CProcessMonitorDlg::CProcessMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProcessMonitorDlg::IDD, pParent)
{
	m_shouldExit = false;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProcessMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_KNOWNLIST, knownBox);
	DDX_Control(pDX, IDC_UNKNOWNLIST, unknownBox);
}

BEGIN_MESSAGE_MAP(CProcessMonitorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_TIMER()
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CProcessMonitorDlg message handlers

BOOL CProcessMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	loadKnownList();
	dlg.Create(IDD_ALERTDLG);
	dlg.parent = this;
	SetTimer(0, 100, NULL);

	NOTIFYICONDATA nid;
	memset(&nid,0,sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = this->GetSafeHwnd();
	sprintf(nid.szTip, "Process Alert");
	nid.hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
	nid.uCallbackMessage = WM_USER;
	nid.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
	BOOL b = Shell_NotifyIcon(NIM_ADD, &nid);
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProcessMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProcessMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProcessMonitorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CProcessMonitorDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int items[30];
	
	while(unknownBox.GetSelItems(30, items) != 0)
	{
		int index = items[0];
		knownList.push_back(unknownList[index]);
		
		for(int j = index; j < unknownList.size() - 1; j++)
		{
			unknownList[j] = unknownList[j+1];
		}
		unknownList.pop_back();

		
		unknownBox.DeleteString(index);
		
		
	}

	//OnOK();
}

void CProcessMonitorDlg::loadKnownList(void)
{
	ifstream file("known.dat");
	char line[1024];
	if(file.is_open())
	{
		file.getline(line, 1023);
		while(strlen(line) != 0)
		{
			knownList.push_back(line);
			file.getline(line, 1023);
		}
	}

	file.close();

}

bool CProcessMonitorDlg::isKnown(string &name)
{
	for(int i = 0; i < knownList.size(); i++)
	{
		if(knownList[i] == name) return true;
	}
	return false;
}

void CProcessMonitorDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default


	DWORD ret;
	DWORD buf[1024];
	EnumProcesses(buf, sizeof(buf), &ret);

	vector<string> runningList;
	vector<string> dlgList;

	for(int i = 0; i < ret/sizeof(DWORD); i++)
	{
		HANDLE h = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, buf[i]);
		if(h)
		{
			char name[1023];
			if(GetProcessImageFileName(h, name, 1024))
			{
				char* l = strrchr(name, '\\')+1;
				
				if(isKnown((string)name))
				{
					runningList.push_back(l);
				}
				else
				{
					if(unknownBox.FindStringExact(0, l) == -1)
					{
						unknownBox.AddString(l);
						unknownList.push_back(name);
						//dlg.SetActiveWindow();
						WINDOWPLACEMENT plc;
						//memset(&plc, 0, sizeof(plc));
						//plc.length = sizeof(plc);
						dlg.GetWindowPlacement(&plc);
						plc.showCmd = SW_RESTORE | SW_SHOW;
						dlg.SetWindowPlacement(&plc);
						dlg.list.AddString(l);
						
						dlg.ShowWindow(SW_SHOW);
						
					}

				}


			}
			CloseHandle(h);
		}
	}


	for(i = 0; i < knownBox.GetCount(); i ++)
	{
		bool found = false;
		char buffer[1024];
		knownBox.GetText(i, buffer);
		string name = buffer;
		for(int j = 0; j < runningList.size(); j++)
		{
			if(runningList[j] == name) 
			{
				runningList[j] = "";
				found = true;
			}
		}

		if(!found)
		{
			knownBox.DeleteString(i);
			i--;
		}
	}

	static bool blue = false;
	blue = !blue;
	NOTIFYICONDATA nid;
	memset(&nid,0,sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = this->GetSafeHwnd();

	if(blue && dlg.IsWindowVisible())
		nid.hIcon = AfxGetApp()->LoadIcon(IDI_ICON2);
	else
		nid.hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
	nid.uFlags = NIF_ICON;
	BOOL b = Shell_NotifyIcon(NIM_MODIFY, &nid);

	for(i = 0; i < runningList.size(); i++)
	{
		if(runningList[i] != "")
			knownBox.AddString(runningList[i].c_str());
	
	}

}

void CProcessMonitorDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	ofstream file("known.dat");
	for(int i = 0; i < knownList.size(); i++)
	{
		file << knownList[i] << endl;
	}
	file.close();

	NOTIFYICONDATA nid;
	memset(&nid,0,sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = this->GetSafeHwnd();
	BOOL b = Shell_NotifyIcon(NIM_DELETE, &nid);

	CDialog::OnClose();
}

BOOL CProcessMonitorDlg::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// TODO: Add your specialized code here and/or call the base class
	if(message == WM_USER)
	{
		if(lParam == WM_LBUTTONDOWN)
		{
			if(this->IsWindowVisible())
			{
				//this->ShowWindow(SW_HIDE);
			} else {
				this->ShowWindow(SW_SHOW);
				this->SetForegroundWindow();
			}
		} else if(lParam == WM_RBUTTONDOWN)
		{
			VERIFY(iconMenu.CreateMenu());
			VERIFY(iconMenu.CreatePopupMenu());
			iconMenu.AppendMenu(MF_STRING, 1, "&Exit");
			POINT point;
			GetCursorPos(&point);
			iconMenu.TrackPopupMenu(TPM_LEFTBUTTON, point.x, point.y, this, 0);
            		
		}
	} else if (message == WM_CLOSE)
	{
		if(m_shouldQuit)
		{
			return CDialog::OnWndMsg(message, wParam, lParam, pResult);
		} else if(this->IsWindowVisible())
		{
			this->ShowWindow(SW_HIDE);
		}
	} else if (message == WM_COMMAND)
	{
		if(wParam == 1)
		{
			m_shouldQuit = true;
			this->PostMessage(WM_QUIT);
		}
	} else {

		return CDialog::OnWndMsg(message, wParam, lParam, pResult);
	}

	return true;
}
